//we want to use the jeep datablocks if we can

datablock FlyingVehicleData(PelicanVehicle)
{
   //Tagged fields for mission editor
      category = "Vehicles";
      displayName = " ";

   //Shapebase Fields
      shapeFile   = "./Pelican.dts";  //.dts File
      emap        = true;
      mass        = 600;
      drag        = 0.4;
      density     = 3;
      
      maxDamage = 1000.00;
      destroyedLevel = 1000.00;
      speedDamageScale = 1.04;
      collDamageThresholdVel = 20.0;
      collDamageMultiplier   = 0.02;

   //Tagged fields for mounting
      minMountDist = 3;   
      numMountPoints = 12;
      mountThread[0] = "sit";
      mountThread[1] = "sit";
      mountThread[2] = "root";
      mountThread[3] = "sit";
      mountThread[4] = "sit";
      mountThread[5] = "sit";
      mountThread[6] = "sit";
      mountThread[7] = "sit";
      mountThread[8] = "sit";
      mountThread[9] = "sit";
      mountThread[10] = "sit";
      mountThread[11] = "sit";
      lookUpLimit = 0.75;
		lookDownLimit = 0.35;
Readyfire=0;

ShootOnClick=1;
shootonclick_Hold=1;
shootonclick_ShootDelay=100;
shootonclick_ReShootDelay=100;
shootonclick_ProjectileCount=1;
shootonclick_RequiredSlot=0;
shootonclick_Sound=gunShot1Sound;

shootonclick_Projectile[0]=gunProjectile;
shootonclick_Position[0]="5 0 0.7";
shootonclick_Velocity[0]="200 0 0";
shootonclick_Scale[0]="0.5 2 0.5";

   //Vehicle Fields:
      jetForce          = 3000;
      jetEnergyDrain    = 0;
      minJetEnergy      = 2;

      massCenter        = "0 0 -1";
      //massBox           = "1 1 1";
      bodyRestitution   = 0.5;
      bodyFriction      = 0.3;
      //softImpactSound   = ; //AudioProfile
      //hardImpactSound   = ; //AudioProfile

      minImpactSpeed    = 25;
      softImpactSpeed   = 25;
      hardImpactSpeed   = 50;
      minRollSpeed      = 0;
      maxSteeringAngle  = 0.785;

      maxDrag        = 50;
      minDrag        = 40;
      integration    = 4;
      collisionTol   = 0.1;
      contactTol     = 0.1;

      cameraRoll     = false;
      cameraMaxDist  = 20;        
      cameraLag      = 0.0;
      cameraDecay    = 0.0;
      cameraOffset   = 2.5;
      cameraTilt     = 0.0;

      //dustEmitter       = ; //ParticleEmitterData
      triggerDustHeight = 3.0;
      dustHeight        = 1.0;

      numDmgEmitterAreas   = 0;
      
      damageEmitter[0] = vehicleBurnEmitter;
      damageEmitterOffset[0] = "0.0 0.0 0.0 ";
      damageLevelTolerance[0] = 0.99;

      damageEmitter[1] = vehicleBurnEmitter;
      damageEmitterOffset[1] = "0.0 0.0 0.0 ";
      damageLevelTolerance[1] = 1.0;

      //splashEmitter[0]        = ; //ParticleEmitterData

      splashFreqMod     = 300.0;
      splashVelEpsilon  = 0.50;

      splash = vehicleSplash;
      splashVelocity = 4.0;
      splashAngle = 67.0;
      splashFreqMod = 300.0;
      splashVelEpsilon = 0.60;
      bubbleEmitTime = 1.4;
      splashEmitter[0] = vehicleFoamDropletsEmitter;
      splashEmitter[1] = vehicleFoamEmitter;
      splashEmitter[2] = vehicleBubbleEmitter;
      mediumSplashSoundVelocity = 10.0;   
      hardSplashSoundVelocity = 20.0;   
      exitSplashSoundVelocity = 5.0;

      exitSplashSoundVelocity    = 2.0;
      softSplashSoundVelocity    = 1.0;
      mediumSplashSoundVelocity  = 2.0;
      hardSplashSoundVelocity    = 3.0;
      //exitingWater               = ;   //AudioProfile
      //impactWaterEasy            = ;   //AudioProfile
      //impactWaterMedium          = ;   //AudioProfile
      //impactWaterHard            = ;   //AudioProfile
      //waterWakeSound             = ;   //AudioProfile

      collDamageThresholdVel  = 20;
      collDamageMultiplier    = 0.05;

   //For Wrench Gui
      uiName   = "Pelican";
      rideAble = true;
      paintable = true;
		
   //Flying vehicle fields
      //jetSound = ;      //AudioProfile
      //engineSound = ;   //AudioProfile

      maneuveringForce        = 6400;
      horizontalSurfaceForce  = 20;
      verticalSurfaceForce    = 30;
      autoInputDamping        = 0.55;
      steeringForce           = 2000;
      steeringRollForce       = 300;
      rollForce               = 6;
      autoAngularForce        = 2400;
      rotationalDrag          = 20;
      autoLinearForce         = 100;
      maxAutoSpeed            = 5;
      hoverHeight             = 3.0;
      createHoverHeight       = 3.0;

      //forwardJetEmitter    = ; //ParticleEmitterData
      //backwardJetEmitter   = ; //ParticleEmitterData
      //downJetEmitter       = ; //ParticleEmitterData
      //trailEmitter         = ; //ParticleEmitterData

      minTrailSpeed        = 1;
      vertThrustMultiple   = 1.0;
   
   //Tagged fields for damage
      initialExplosionProjectile = vehicleExplosionProjectile;
      initialExplosionOffset = 0;         //offset only uses a z value for now

      burnTime = 500;

      finalExplosionProjectile = vehicleFinalExplosionProjectile;
      finalExplosionOffset = 0.5;          //offset only uses a z value for now

      minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
      runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
      runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};
package addVehicleVelocity
{
//This is located in event_vehicle but instead of forcing that, I just re did the function.
	function Vehicle::addVelocity(%vehicle,%velocity) 
	{
		%vehicle.setVelocity(vectorAdd(%vehicle.getVelocity(),%velocity));
	}
};
activatePackage(addVehicleVelocity);

   function PelicanVehicle::onTrigger(%this,%obj,%client)
   {
	
	%obj.addvelocity("0 0 0.3");

   }


