datablock ShapeBaseImageData(PelicanMGSmokeImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 1;

	stateName[0]                  = "Ready";
	stateTransitionOnTimeout[0]   = "FireA";
	stateTimeoutValue[0]          = 0.01;

	stateName[1]                  = "FireA";
	stateTransitionOnTimeout[1]   = "Done";
	stateWaitForTimeout[1]        = True;
	stateTimeoutValue[1]          = 0.05;
	stateEmitter[1]               = gunFlashEmitter;
	stateEmitterTime[1]           = 0.05;


	stateName[2]                  = "Done";
	stateScript[2]                = "onDone";
};
function PelicanMGSmokeImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}



//shell

datablock TSShapeConstructor(PelicanMGTurretDts)
{
	baseShape  = "./PelicanMGTurret.dts";
	sequence0  = "./MG_root.dsq root";

	sequence1  = "./MG_root.dsq run";
	sequence2  = "./MG_root.dsq walk";
	sequence3  = "./MG_root.dsq back";
	sequence4  = "./MG_root.dsq side";

	sequence5  = "./MG_root.dsq crouch";
	sequence6  = "./MG_root.dsq crouchRun";
	sequence7  = "./MG_root.dsq crouchBack";
	sequence8  = "./MG_root.dsq crouchSide";

	sequence9  = "./MG_look.dsq look";
	sequence10 = "./MG_root.dsq headside";
	sequence11 = "./MG_root.dsq headUp";

	sequence12 = "./MG_root.dsq jump";
	sequence13 = "./MG_root.dsq standjump";
	sequence14 = "./MG_root.dsq fall";
	sequence15 = "./MG_root.dsq land";

	sequence16 = "./MG_root.dsq armAttack";
	sequence17 = "./MG_root.dsq armReadyLeft";
	sequence18 = "./MG_root.dsq armReadyRight";
	sequence19 = "./MG_root.dsq armReadyBoth";
	sequence20 = "./MG_root.dsq spearready";  
	sequence21 = "./MG_root.dsq spearThrow";

	sequence22 = "./MG_root.dsq talk";  

	sequence23 = "./MG_root.dsq death1"; 
	
	sequence24 = "./MG_root.dsq shiftUp";
	sequence25 = "./MG_root.dsq shiftDown";
	sequence26 = "./MG_root.dsq shiftAway";
	sequence27 = "./MG_root.dsq shiftTo";
	sequence28 = "./MG_root.dsq shiftLeft";
	sequence29 = "./MG_root.dsq shiftRight";
	sequence30 = "./MG_root.dsq rotCW";
	sequence31 = "./MG_root.dsq rotCCW";

	sequence32 = "./MG_root.dsq undo";
	sequence33 = "./MG_root.dsq plant";

	sequence34 = "./MG_root.dsq sit";

	sequence35 = "./MG_root.dsq wrench";
};    	







datablock PlayerData(PelicanMGTurretPlayer)
{
   Hold = 1;

   renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./PelicanMGTurret.dts";
   cameraMaxDist = 15;
   cameraTilt = 0.261;
   cameraVerticalOffset = 5.3;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -0.4;
   maxLookAngle = 0.5;
   maxFreelookAngle = 3.0;

   mass = 200;
   drag = 10;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 0 * 0;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 0;
   maxUnderwaterBackwardSpeed = 0;
   maxUnderwaterSideSpeed = 0;

   jumpForce = 0 * 0; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("2.5 2.5 1.7", 4); 
   crouchBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 
   proneBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
	
   jetEmitter = playerJetEmitter;
   jetGroundEmitter = playerJetGroundEmitter;
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available


   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	rideable = true;
   lookUpLimit = 0.6;
   lookDownLimit = 0.1;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "root";

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = false;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};

//we want to use the jeep datablocks if we can

datablock FlyingVehicleData(PelicanMGVehicle)
{
   //Tagged fields for mission editor
      category = "Vehicles";
      displayName = " ";

   //Shapebase Fields
      shapeFile   = "./Pelican.dts";  //.dts File
      emap        = true;
      mass        = 600;
      drag        = 0.7;
      density     = 3;
      
      maxDamage = 1000.00;
      destroyedLevel = 1000.00;
      speedDamageScale = 1.04;
      collDamageThresholdVel = 20.0;
      collDamageMultiplier   = 0.02;

   //Tagged fields for mounting
      minMountDist = 3;   
      numMountPoints = 12;
      mountThread[0] = "sit";
      mountThread[1] = "sit";
      mountThread[2] = "root";
      mountThread[3] = "sit";
      mountThread[4] = "sit";
      mountThread[5] = "sit";
      mountThread[6] = "sit";
      mountThread[7] = "sit";
      mountThread[8] = "sit";
      mountThread[9] = "sit";
      mountThread[10] = "sit";
      mountThread[11] = "sit";

      lookUpLimit = 0.75;
		lookDownLimit = 0.35;
Readyfire=0;

ShootOnClick=1;
shootonclick_Hold=1;
shootonclick_ShootDelay=100;
shootonclick_ReShootDelay=100;
shootonclick_ProjectileCount=1;
shootonclick_RequiredSlot=0;
shootonclick_Sound=gunShot1Sound;

shootonclick_Projectile[0]=gunProjectile;
shootonclick_Position[0]="5 0 0.7";
shootonclick_Velocity[0]="200 0 0";
shootonclick_Scale[0]="0.5 2 0.5";
   //Vehicle Fields:
      jetForce          = 3000;
      jetEnergyDrain    = 0;
      minJetEnergy      = 2;

      massCenter        = "0 0 -1";
      //massBox           = "1 1 1";
      bodyRestitution   = 0.5;
      bodyFriction      = 0.3;
      //softImpactSound   = ; //AudioProfile
      //hardImpactSound   = ; //AudioProfile

      minImpactSpeed    = 25;
      softImpactSpeed   = 25;
      hardImpactSpeed   = 50;
      minRollSpeed      = 0;
      maxSteeringAngle  = 0.785;

      maxDrag        = 50;
      minDrag        = 40;
      integration    = 4;
      collisionTol   = 0.1;
      contactTol     = 0.1;

      cameraRoll     = false;
      cameraMaxDist  = 20;        
      cameraLag      = 0.0;
      cameraDecay    = 0.0;
      cameraOffset   = 2.5;
      cameraTilt     = 0.0;

      //dustEmitter       = ; //ParticleEmitterData
      triggerDustHeight = 3.0;
      dustHeight        = 1.0;

      numDmgEmitterAreas   = 0;
      
      damageEmitter[0] = vehicleBurnEmitter;
      damageEmitterOffset[0] = "0.0 0.0 0.0 ";
      damageLevelTolerance[0] = 0.99;

      damageEmitter[1] = vehicleBurnEmitter;
      damageEmitterOffset[1] = "0.0 0.0 0.0 ";
      damageLevelTolerance[1] = 1.0;

      //splashEmitter[0]        = ; //ParticleEmitterData

      splashFreqMod     = 300.0;
      splashVelEpsilon  = 0.50;

      splash = vehicleSplash;
      splashVelocity = 4.0;
      splashAngle = 67.0;
      splashFreqMod = 300.0;
      splashVelEpsilon = 0.60;
      bubbleEmitTime = 1.4;
      splashEmitter[0] = vehicleFoamDropletsEmitter;
      splashEmitter[1] = vehicleFoamEmitter;
      splashEmitter[2] = vehicleBubbleEmitter;
      mediumSplashSoundVelocity = 10.0;   
      hardSplashSoundVelocity = 20.0;   
      exitSplashSoundVelocity = 5.0;

      exitSplashSoundVelocity    = 2.0;
      softSplashSoundVelocity    = 1.0;
      mediumSplashSoundVelocity  = 2.0;
      hardSplashSoundVelocity    = 3.0;
      //exitingWater               = ;   //AudioProfile
      //impactWaterEasy            = ;   //AudioProfile
      //impactWaterMedium          = ;   //AudioProfile
      //impactWaterHard            = ;   //AudioProfile
      //waterWakeSound             = ;   //AudioProfile

      collDamageThresholdVel  = 20;
      collDamageMultiplier    = 0.05;

   //For Wrench Gui
      uiName   = "Pelican- Turret";
      rideAble = true;
      paintable = true;
		
   //Flying vehicle fields
      //jetSound = ;      //AudioProfile
      //engineSound = ;   //AudioProfile

      maneuveringForce        = 6400;
      horizontalSurfaceForce  = 20;
      verticalSurfaceForce    = 30;
      autoInputDamping        = 0.55;
      steeringForce           = 2000;
      steeringRollForce       = 300;
      rollForce               = 6;
      autoAngularForce        = 2400;
      rotationalDrag          = 20;
      autoLinearForce         = 100;
      maxAutoSpeed            = 5;
      hoverHeight             = 3.0;
      createHoverHeight       = 3.0;

      //forwardJetEmitter    = ; //ParticleEmitterData
      //backwardJetEmitter   = ; //ParticleEmitterData
      //downJetEmitter       = ; //ParticleEmitterData
      //trailEmitter         = ; //ParticleEmitterData

      minTrailSpeed        = 1;
      vertThrustMultiple   = 1.0;
   
   //Tagged fields for damage
      initialExplosionProjectile = vehicleExplosionProjectile;
      initialExplosionOffset = 0;         //offset only uses a z value for now

      burnTime = 500;

      finalExplosionProjectile = vehicleFinalExplosionProjectile;
      finalExplosionOffset = 0.5;          //offset only uses a z value for now

      minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
      runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
      runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};

function PelicanMGVehicle::onAdd(%this,%obj)
{

   // turret
 %t = new AIPlayer()
 {
   dataBlock = PelicanMGTurretPlayer;
};
MissionCleanup.add(%t);
%obj.mountObject(%t, 2);
%obj.turret = %t;
%obj.creationTime = getSimTime();
%t.schedule(10,"rigTurret");

//-------------------------------------cannon2

//-------------------------------------cannon3

//-------------------------------------cannon4







}
function Player::rigTurret(%obj)
{
   if(%obj.dataBlock !$= PelicanMGTurretPlayer)
	   return;

   if(!isObject(%obj))
	   return;

   %parent = %obj.getObjectMount();
   if(!isObject(%parent))
	   return;

   %obj.spawnBrick = %parent.spawnBrick;
   %obj.brickGroup = %parent.brickGroup;
}
function PelicanMGVehicle::onRemove(%this,%obj)
{
   if(isObject(%obj.turret))
	   %obj.turret.delete();

}
function PelicanMGTurretPlayer::onDriverLeave(%this,%obj)
{
   %obj.setTransform("0 0 0 0 0 0 0");
}

package PelicanMGPackage
{

 
   function Player::burn(%obj,%time)
   {
      if(%obj.dataBlock $= PelicanMGTurretPlayer)
         return;
      else
         Parent::burn(%obj,%time);
   }

   function PelicanMGVehicle::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      if((%obj.getDamageLevel()+%amm) >= %this.maxDamage)
      {
         if(%obj.destroyed)
            return;

         %obj.setNodeColor("ALL","0 0 0 1");
         if(isObject(%obj.turret))
         {
            %obj.turret.delete();
         }
         //else
         //{
            //%p = new Projectile()
            //{
               //dataBlock = PelicanMGExplosionProjectile;
               //initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               //initialVelocity = "0 0 1";
               //client = %obj.lastDamageClient;
               //sourceClient = %obj.lastDamageClient;
            //};
            //MissionCleanup.add(%p);
         //}
         if(%obj.destroyed)
            return;

         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(%this.burnTime,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
      }
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }
   
   function Player::emote(%obj,%emote)
   {
      if(%obj.dataBlock $= PelicanMGTurretPlayer)
	      return;
      Parent::emote(%obj,%emote);
   }
      function PelicanMGTurretPlayer::onDamage(%this,%obj,%ammount)
   {
      if(%obj.dataBlock $= PelicanMGTurretPlayer)
         return;
	   Parent::onDamage(%this,%obj,%ammount);
   }
   
   //------------------------------------------------------------------------------------------------------------------------------------------------------------
      function PelicanMGTurretPlayer::onDisabled(%this,%obj,%state)
   {
      %obj.schedule(10,"delete");
      %player = %obj.getMountedObject(0);
      if(isObject(%player))
      {
         %obj.getObjectMount().schedule(10,"mountObject",%player,2);
      }
   }

   function PelicanMGTurretPlayer::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      //scale the damage ammount as if this was a vehicle
      %amm *= $Damage::VehicleDamageScale[%type];

      if(%obj.getDamageLevel()+%amm > %this.maxDamage)
         %obj.setDamageLevel(%this.maxDamage);
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this,%obj,%col,%slot);
      if(%col.getDataBlock() == PelicanMGVehicle.getId())
      {
         if(%slot $= 2)
         {
            %obj.setLookLimits(1,0);
         }
	

		 
      }
      else if(%col.getDataBlock() == PelicanMGTurretPlayer.getId())
      {
         %client = %obj.client;
         if(isObject(%client))
            ServerCmdUnUseTool(%client);
      }
   }

  function Player::PelicanShoot(%obj,%triggerNum,%val)
   {
      	if(!%val) 
	{
		cancel(%obj.Pelican_reshoot);
		return;
	}
      
      %mount = %obj.getObjectMount();

      //hack so we can shoot if we are a tank turret
      if(%obj.getDataBlock().getID() == PelicanMGTurretPlayer.getID())
         %mount = %obj;

      if(isObject(%mount))
      {
         if(%mount.getDataBlock() == PelicanMGTurretPlayer.getId() && %triggerNum == 0 && %val)
         {
            %client = %obj.client;
            if(isObject(%client))
               ServerCmdUnUseTool(%client);



	%vector = %mount.getEyeVector(); //Get the direction they're aiming
	%velocity = VectorScale(%vector, 80); //Lengthen the vector to be the speed of the projectile we want
	%x = (getRandom() - 0.5) * 0.02; //Calculate X, Y, and Z spread randomizations
	%y = (getRandom() - 0.5) * 0.02;
	%z = (getRandom() - 0.5) * 0.02;
	%mat = MatrixCreateFromEuler(%x SPC %y SPC %z);
	%velocity = MatrixMulVector(%mat, %velocity); //Randomize the lengthened vector.
	%scaleFactor = getWord(%mount.getScale(), 2); //Get the scale so we can scale the projectile.
	%p = new projectile() //Create the projectile.
	{
		dataBlock = Gunprojectile;
		initialVelocity = %velocity;
		initialPosition = %mount.getEyePoint();
		sourceObject = %obj;
		sourceSlot = %triggerNum;
		client = %obj.client;
		scale = %scaleFactor;
	};
	MissionCleanup.add(%p);
	%mount.mountImage(PelicanMGSmokeImage,1);
	serverPlay3D(Gunshot1Sound,%obj.getPosition());
	%obj.lastShotTime = getSimTime();
	%ReshootDelay = 100;
	%ShootDelay = 1000;
	%Hold = 1;
	if(%Hold == 1)
	{
		%obj.Pelican_reshoot= %obj.schedule(%ReshootDelay,PelicanShoot,%triggerNum,%val);
		//%obj.Pelican_reshoot= %obj.schedule(5,Pelican_Shoot,%triggerNum,%val);
	}

	%obj.client.Pelican_LastFireTime=$Sim::Time+%ShootDelay/1000;

            return;
         }
      }
      
   }




   
  function armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
	if(%obj.getClassName()$="Player")
		{
			if(%triggerNum $= 0)
			{
				if(%val)
				{
					if($Sim::Time<%obj.client.Pelican_LastFireTime)
					{
					
						return;
					}
				}
				%obj.PelicanShoot(%triggerNum,%val);
			}
		}
	Parent::onTrigger(%this,%obj,%triggerNum,%val);
   }
   
   
   };
activatepackage(PelicanMGPackage);


   function PelicanMGVehicle::onTrigger(%this,%obj,%client)
   {
	
	%obj.addvelocity("0 0 0.3");

   }


